package com.icingDialer

import io.flutter.embedding.android.FlutterActivity
import android.os.Build
import android.security.keystore.KeyGenParameterSpec
import android.security.keystore.KeyProperties
import androidx.annotation.NonNull
import io.flutter.embedding.android.FlutterActivity
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.plugin.common.MethodChannel
import java.security.KeyStore
import javax.crypto.KeyGenerator
import javax.crypto.SecretKey
import android.util.Base64

class MainActivity: FlutterActivity() {
    private val CHANNEL = "com.icingDialer/keystore"

    override fun configureFlutterEngine(flutterEngine: FlutterEngine) {
        super.configureFlutterEngine(flutterEngine)
        MethodChannel(flutterEngine.dartExecutor.binaryMessenger, CHANNEL).setMethodCallHandler { call, result ->
            when (call.method) {
                "generateKeyPair" -> {
                    val alias = call.argument<String>("alias")
                    if (alias != null) {
                        try {
                            KeyGeneratorHelper.generateECKeyPair(alias)
                            result.success(null)
                        } catch (e: Exception) {
                            result.error("KEY_GENERATION_FAILED", e.message, null)
                        }
                    } else {
                        result.error("INVALID_ARGUMENT", "Alias is required", null)
                    }
                }
                // Handle other methods: signData, getPublicKey, deleteKeyPair
                else -> result.notImplemented()
            }
        }
    }
}
